#include <stdio.h>
#include <stdlib.h>

// This example illustrates using a pointer to pass
// data by reference into and out of a function.

// the difference in ascii table between lower 
// and corresponding uppercase letter
static char cap_diff = 'a'-'A';

/* makes a string uppercase, 
 * in place (i.e., overwrites the original string)
 */
void capitalize(char* s) {
  char* p = s;        
  while (*p != '\0') {
    if (*p < 'a' || *p > 'z') {
      fprintf(stderr, "only works on lowercase letters\n");
      exit(2);
    }
    *p -= cap_diff;
    ++p;
  }
}

/* takes a lowercase string of ascii characters
 * and prints it in uppercase
 */
int main(int argc, char** argv) {
  if (argc != 2) {
    fprintf(stderr, "usage: %s STRING\n", argv[0]);
    exit(1);
  }
  
  char* str = argv[1];

  printf("Input: %s\n", str);
  capitalize(str);
  printf("Output: %s\n", str);
}
